#include "mpi.h"
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>

#define MASTER 0
#define TAG    1

void loop_printf(int iterations, char * format, ...)
{
	int i;
	va_list params;


	for (i = 0; i < iterations; i++) {
		va_start(params, format);
		vprintf(format, params);
		va_end(params);
	}
}

int main(int argc, char* argv[])
{
	MPI_Status status;
	int myRank, nTasks, i, Buffer;
	int iterations;

	MPI_Init(&argc, &argv);
	MPI_Comm_size(MPI_COMM_WORLD, &nTasks);
	MPI_Comm_rank(MPI_COMM_WORLD, &myRank);

	printf("Please enter number of iterations\n");
	scanf("%d", &iterations);

	if (myRank == MASTER) {
		loop_printf(iterations, "Hi from Master, my Rank is %d\n", myRank);

		for (i = 1; i < nTasks; i++) {
			MPI_Recv(&Buffer, 1, MPI_INT, i, TAG, MPI_COMM_WORLD, &status);
			loop_printf(iterations, "Received Message from Node %d\n", Buffer);
		}
	} else {
		MPI_Send(&myRank, 1, MPI_INT, MASTER, TAG, MPI_COMM_WORLD);
	}

	loop_printf(iterations, "Bye from %d\n", myRank);
	MPI_Finalize();
	return 0;
}
