#include "mpi.h"
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#define MASTER 0
#define TAG    1

#define TOSEND 42
#define TOMODIFY 19

int main(int argc, char* argv[])
{
	MPI_Status status;
	int myRank, nTasks, i, Buffer;
	int buffered;

	MPI_Init(&argc, &argv);
	MPI_Comm_size(MPI_COMM_WORLD, &nTasks);
	MPI_Comm_rank(MPI_COMM_WORLD, &myRank);

	if (myRank == MASTER) {
		printf("Hi from Master, my Rank is %d\n", myRank);
		buffered = 1;

		for (i = 1; i < nTasks; i++) {
			sleep(5);
			MPI_Recv(&Buffer, 1, MPI_INT, i, TAG, MPI_COMM_WORLD, &status);
			if (Buffer != TOSEND) {
				buffered = 0;
			}
		}

		if (buffered == 0) {
			printf("Recieved motified data. MPI_Sends unbuffered\n");
		} else {
			printf("Recieved unmotified data. Maybe MPI_Sends buffered\n");
		}
	} else {
		Buffer = TOSEND;
		MPI_Send(&Buffer, 1, MPI_INT, MASTER, TAG, MPI_COMM_WORLD);
		Buffer = TOMODIFY;
	}

	printf("Bye from %d\n", myRank);
	MPI_Finalize();
	return 0;
}
