#include "mpi.h"
#include <stdlib.h>
#include <stdio.h>

#define MASTER 0
#define TAG    1

#define BUFFERSIZE (1024*1024)
#define TESTS 64

#ifndef SENDTEST
#error Please define SENDTEST
#endif

int main(int argc, char* argv[])
{
	MPI_Status status;
	int myRank, nTasks, i;
	unsigned char Buffer[BUFFERSIZE];
	double starttime, endtime, benchedtime;
	unsigned int cursize;

	MPI_Init(&argc, &argv);
	MPI_Comm_size(MPI_COMM_WORLD, &nTasks);
	MPI_Comm_rank(MPI_COMM_WORLD, &myRank);

	if (myRank == MASTER) {
		for (cursize = 1; cursize <= BUFFERSIZE; cursize *= 2) {
			benchedtime = 0.0;
			starttime = MPI_Wtime();
			for (i = 0; i < TESTS; i++) {
				SENDTEST(&Buffer, cursize, MPI_BYTE, MASTER + 1, TAG, MPI_COMM_WORLD);
			}
			endtime = MPI_Wtime();
			benchedtime = endtime - starttime;
			printf("%d %f\n", cursize, benchedtime / TESTS);
		}
	} else if (myRank == MASTER + 1) {
		for (cursize = 1; cursize <= BUFFERSIZE; cursize *= 2) {
			for (i = 0; i < TESTS; i++) {
				MPI_Recv(&Buffer, cursize, MPI_BYTE, MASTER, TAG, MPI_COMM_WORLD, &status);
			}
		}
	}

	MPI_Finalize();
	return 0;
}
